Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 877)
+++ inc/core/class.dc.blog.php	(revision 836)
@@ -1067,4 +1714,376 @@
 	}
 	//@}
+	
+	/// @name Comments management methods
+	//@{
+	/**
+	Retrieves comments. <b>$params</b> is an array taking the following
+	optionnal parameters:
+	
+	- no_content: Don't retrieve comment content
+	- post_type: Get only entries with given type (default no type, array for many types) 
+	- post_id: (integer) Get comments belonging to given post_id
+	- cat_id: (integer or array) Get comments belonging to entries of given category ID
+	- comment_id: (integer) Get comment with given ID
+	- comment_status: (integer) Get comments with given comment_status
+	- comment_trackback: (integer) Get only comments (0) or trackbacks (1)
+	- comment_ip: (string) Get comments with given IP address
+	- post_url: Get entry with given post_url field
+	- user_id: (integer) Get entries belonging to given user ID
+	- q_author: Search comments by author
+	- sql: Append SQL string at the end of the query
+	- from: Append SQL string after "FROM" statement in query
+	- order: Order of results (default "ORDER BY comment_dt DES")
+	- limit: Limit parameter
+	- sql_only : return the sql request instead of results. Only ids are selected
+	
+	@param	params		<b>array</b>		Parameters
+	@param	count_only	<b>boolean</b>		Only counts results
+	@return	<b>record</b>	A record with some more capabilities
+	*/
+	public function getComments($params=array(),$count_only=false)
+	{
+		if ($count_only)
+		{
+			$strReq = 'SELECT count(comment_id) ';
+		}
+		elseif (!empty($params['sql_only'])) 
+		{
+			$strReq = 'SELECT P.post_id ';
+		}
+		else
+		{
+			if (!empty($params['no_content'])) {
+				$content_req = '';
+			} else {
+				$content_req = 'comment_content, ';
+			}
+			
+			if (!empty($params['columns']) && is_array($params['columns'])) {
+				$content_req .= implode(', ',$params['columns']).', ';
+			}
+			
+			$strReq =
+			'SELECT C.comment_id, comment_dt, comment_tz, comment_upddt, '.
+			'comment_author, comment_email, comment_site, '.
+			$content_req.' comment_trackback, comment_status, '.
+			'comment_spam_status, comment_spam_filter, comment_ip, '.
+			'P.post_title, P.post_url, P.post_id, P.post_password, P.post_type, '.
+			'P.post_dt, P.user_id, U.user_email, U.user_url ';
+		}
+		
+		$strReq .=
+		'FROM '.$this->prefix.'comment C '.
+		'INNER JOIN '.$this->prefix.'post P ON C.post_id = P.post_id '.
+		'INNER JOIN '.$this->prefix.'user U ON P.user_id = U.user_id ';
+		
+		if (!empty($params['from'])) {
+			$strReq .= $params['from'].' ';
+		}
+		
+		$strReq .=
+		"WHERE P.blog_id = '".$this->con->escape($this->id)."' ";
+		
+		if (!$this->core->auth->check('contentadmin',$this->id)) {
+			$strReq .= 'AND ((comment_status = 1 AND P.post_status = 1 ';
+			
+			if ($this->without_password) {
+				$strReq .= 'AND post_password IS NULL ';
+			}
+			$strReq .= ') ';
+			
+			if ($this->core->auth->userID()) {
+				$strReq .= "OR P.user_id = '".$this->con->escape($this->core->auth->userID())."')";
+			} else {
+				$strReq .= ') ';
+			}
+		}
+		
+		if (!empty($params['post_type']))
+		{
+			$strReq .= 'AND post_type '.$this->con->in($params['post_type']);
+		}
+		
+		if (isset($params['post_id']) && $params['post_id'] !== '') {
+			$strReq .= 'AND P.post_id = '.(integer) $params['post_id'].' ';
+		}
+		
+		if (isset($params['cat_id']) && $params['cat_id'] !== '') {
+			$strReq .= 'AND P.cat_id = '.(integer) $params['cat_id'].' ';
+		}
+		
+		if (isset($params['comment_id']) && $params['comment_id'] !== '') {
+			$strReq .= 'AND comment_id = '.(integer) $params['comment_id'].' ';
+		}
+		
+		if (isset($params['comment_status'])) {
+			$strReq .= 'AND comment_status = '.(integer) $params['comment_status'].' ';
+		}
+		
+		if (!empty($params['comment_status_not']))
+		{
+			$strReq .= 'AND comment_status <> '.(integer) $params['comment_status_not'].' ';
+		}
+		
+		if (isset($params['comment_trackback'])) {
+			$strReq .= 'AND comment_trackback = '.(integer) (boolean) $params['comment_trackback'].' ';
+		}
+		
+		if (isset($params['comment_ip'])) {
+			$strReq .= "AND comment_ip = '".$this->con->escape($params['comment_ip'])."' ";
+		}
+		
+		if (isset($params['q_author'])) {
+			$q_author = $this->con->escape(str_replace('*','%',strtolower($params['q_author'])));
+			$strReq .= "AND LOWER(comment_author) LIKE '".$q_author."' ";
+		}
+		
+		if (!empty($params['search']))
+		{
+			$words = text::splitWords($params['search']);
+			
+			if (!empty($words))
+			{
+				# --BEHAVIOR coreCommentSearch
+				if ($this->core->hasBehavior('coreCommentSearch')) {
+					$this->core->callBehavior('coreCommentSearch',$this->core,array(&$words,&$strReq,&$params));
+				}
+				
+				if ($words)
+				{
+					foreach ($words as $i => $w) {
+						$words[$i] = "comment_words LIKE '%".$this->con->escape($w)."%'";
+					}
+					$strReq .= 'AND '.implode(' AND ',$words).' ';
+				}
+			}
+		}
+		
+		if (!empty($params['sql'])) {
+			$strReq .= $params['sql'].' ';
+		}
+		
+		if (!$count_only)
+		{
+			if (!empty($params['order'])) {
+				$strReq .= 'ORDER BY '.$this->con->escape($params['order']).' ';
+			} else {
+				$strReq .= 'ORDER BY comment_dt DESC ';
+			}
+		}
+		
+		if (!$count_only && !empty($params['limit'])) {
+			$strReq .= $this->con->limit($params['limit']);
+		}
+
+		if (!empty($params['sql_only'])) {
+			return $strReq;
+		}
+		
+		$rs = $this->con->select($strReq);
+		$rs->core = $this->core;
+		$rs->extend('rsExtComment');
+		
+		# --BEHAVIOR-- coreBlogGetComments
+		$this->core->callBehavior('coreBlogGetComments',$rs);
+		
+		return $rs;
+	}
+	
+	/**
+	Creates a new comment. Takes a cursor as input and returns the new comment
+	ID.
+	
+	@param	cur		<b>cursor</b>		Comment cursor
+	@return	<b>integer</b>		New comment ID
+	*/
+	public function addComment($cur)
+	{
+		$this->con->writeLock($this->prefix.'comment');
+		try
+		{
+			# Get ID
+			$rs = $this->con->select(
+				'SELECT MAX(comment_id) '.
+				'FROM '.$this->prefix.'comment ' 
+			);
+			
+			$cur->comment_id = (integer) $rs->f(0) + 1;
+			$cur->comment_upddt = date('Y-m-d H:i:s');
+			
+			$offset = dt::getTimeOffset($this->settings->system->blog_timezone);
+			$cur->comment_dt = date('Y-m-d H:i:s',time() + $offset);
+			$cur->comment_tz = $this->settings->system->blog_timezone;
+			
+			$this->getCommentCursor($cur);
+			
+			if ($cur->comment_ip === null) {
+				$cur->comment_ip = http::realIP();
+			}
+			
+			# --BEHAVIOR-- coreBeforeCommentCreate
+			$this->core->callBehavior('coreBeforeCommentCreate',$this,$cur);
+			
+			$cur->insert();
+			$this->con->unlock();
+		}
+		catch (Exception $e)
+		{
+			$this->con->unlock();
+			throw $e;
+		}
+		
+		# --BEHAVIOR-- coreAfterCommentCreate
+		$this->core->callBehavior('coreAfterCommentCreate',$this,$cur);
+		
+		$this->triggerComment($cur->comment_id);
+		if ($cur->comment_status != -2) {
+			$this->triggerBlog();
+		}	
+		return $cur->comment_id;
+	}
+	
+	/**
+	Updates an existing comment.
+	
+	@param	id		<b>integer</b>		Comment ID
+	@param	cur		<b>cursor</b>		Comment cursor
+	*/
+	public function updComment($id,$cur)
+	{
+		if (!$this->core->auth->check('usage,contentadmin',$this->id)) {
+			throw new Exception(__('You are not allowed to update comments'));
+		}
+		
+		$id = (integer) $id;
+		
+		if (empty($id)) {
+			throw new Exception(__('No such comment ID'));
+		}
+		
+		$rs = $this->getComments(array('comment_id' => $id));
+		
+		if ($rs->isEmpty()) {
+			throw new Exception(__('No such comment ID'));
+		}
+		
+		#If user is only usage, we need to check the post's owner
+		if (!$this->core->auth->check('contentadmin',$this->id))
+		{
+			if ($rs->user_id != $this->core->auth->userID()) {
+				throw new Exception(__('You are not allowed to update this comment'));
+			}
+		}
+		
+		$this->getCommentCursor($cur);
+		
+		$cur->comment_upddt = date('Y-m-d H:i:s');
+		
+		if (!$this->core->auth->check('publish,contentadmin',$this->id)) {
+			$cur->unsetField('comment_status');
+		}
+		
+		# --BEHAVIOR-- coreBeforeCommentUpdate
+		$this->core->callBehavior('coreBeforeCommentUpdate',$this,$cur,$rs);
+		
+		$cur->update('WHERE comment_id = '.$id.' ');
+		
+		# --BEHAVIOR-- coreAfterCommentUpdate
+		$this->core->callBehavior('coreAfterCommentUpdate',$this,$cur,$rs);
+		
+		$this->triggerComment($id);
+		$this->triggerBlog();
+	}
+	
+	/**
+	Updates comment status.
+	
+	@param	id		<b>integer</b>		Comment ID
+	@param	status	<b>integer</b>		Comment status
+	*/
+	public function updCommentStatus($id,$status)
+	{
+		if (!$this->core->auth->check('publish,contentadmin',$this->id)) {
+			throw new Exception(__("You are not allowed to change this comment's status"));
+		}
+		
+		$cur = $this->con->openCursor($this->prefix.'comment');
+		$cur->comment_status = (integer) $status;
+		$this->updComment($id,$cur);
+	}
+	
+	/**
+	Delete a comment
+	
+	@param	id		<b>integer</b>		Comment ID
+	*/
+	public function delComment($id)
+	{
+		if (!$this->core->auth->check('delete,contentadmin',$this->id)) {
+			throw new Exception(__('You are not allowed to delete comments'));
+		}
+		
+		$id = (integer) $id;
+		
+		if (empty($id)) {
+			throw new Exception(__('No such comment ID'));
+		}
+		
+		#If user can only delete, we need to check the post's owner
+		if (!$this->core->auth->check('contentadmin',$this->id))
+		{
+			$strReq = 'SELECT P.post_id '.
+					'FROM '.$this->prefix.'post P, '.$this->prefix.'comment C '.
+					'WHERE P.post_id = C.post_id '.
+					"AND P.blog_id = '".$this->con->escape($this->id)."' ".
+					'AND comment_id = '.$id.' '.
+					"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
+			
+			$rs = $this->con->select($strReq);
+			
+			if ($rs->isEmpty()) {
+				throw new Exception(__('You are not allowed to delete this comment'));
+			}
+		}
+		
+		$strReq = 'DELETE FROM '.$this->prefix.'comment '.
+				'WHERE comment_id = '.$id.' ';
+		
+		$this->triggerComment($id,true);
+		$this->con->execute($strReq);
+		$this->triggerBlog();
+	}
+	
+	private function getCommentCursor($cur)
+	{
+		if ($cur->comment_content !== null && $cur->comment_content == '') {
+			throw new Exception(__('You must provide a comment'));
+		}
+		
+		if ($cur->comment_author !== null && $cur->comment_author == '') {
+			throw new Exception(__('You must provide an author name'));
+		}
+		
+		if ($cur->comment_email != '' && !text::isEmail($cur->comment_email)) {
+			throw new Exception(__('Email address is not valid.'));
+		}
+		
+		if ($cur->comment_site !== null && $cur->comment_site != '') {
+			if (!preg_match('|^http(s?)://|',$cur->comment_site)) {
+				$cur->comment_site = 'http://'.$cur->comment_site;
+			}
+		}
+		
+		if ($cur->comment_status === null) {
+			$cur->comment_status = (integer) $this->settings->system->comments_pub;
+		}
+		
+		# Words list
+		if ($cur->comment_content !== null)
+		{
+			$cur->comment_words = implode(' ',text::splitWords($cur->comment_content));
+		}
+	}
+	//@}
 }
 ?>
Index: inc/core/class.dc.categories.php
===================================================================
--- inc/core/class.dc.categories.php	(revision 270)
+++ inc/core/class.dc.categories.php	(revision 270)
@@ -0,0 +1,483 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+# nestedTree class is based on excellent work of Kuzma Feskov
+# (http://php.russofile.ru/ru/authors/sql/nestedsets01/)
+#
+# One day we'll move nestedTree to Clearbricks.
+
+class dcCategories extends nestedTree
+{
+	protected $f_left = 'cat_lft';
+	protected $f_right = 'cat_rgt';
+	protected $f_id = 'cat_id';
+	
+	protected $core;
+	protected $blog_id;
+	
+	public function __construct($core)
+	{
+		$this->core =& $core;
+		$this->con =& $core->con;
+		$this->blog_id = $core->blog->id;
+		$this->table = $core->prefix.'category';
+		$this->add_condition = array('blog_id' => "'".$this->con->escape($this->blog_id)."'");
+	}
+	
+	public function getChildren($start=0,$id=null,$sort='asc',$fields=array())
+	{
+		$fields = array_merge(array('cat_title','cat_url','cat_desc'),$fields);
+		return parent::getChildren($start,$id,$sort,$fields);
+	}
+	
+	public function getParents($id,$fields=array())
+	{
+		$fields = array_merge(array('cat_title','cat_url','cat_desc'),$fields);
+		return parent::getParents($id,$fields);
+	}
+	
+	public function getParent($id,$fields=array())
+	{
+		$fields = array_merge(array('cat_title','cat_url','cat_desc'),$fields);
+		return parent::getParent($id,$fields);
+	}
+}
+
+abstract class nestedTree
+{
+	protected $con;
+	
+	protected $table;
+	protected $f_left;
+	protected $f_right;
+	protected $f_id;
+	
+	protected $add_condition = array();
+	
+	protected $parents;
+	
+	public function __construct($con)
+	{
+		$this->con =& $con;
+	}
+	
+	public function getChildren($start=0,$id=null,$sort='asc',$fields=array())
+	{
+		$fields = count($fields) > 0 ? ', C2.'.implode(', C2.',$fields) : '';
+		
+		$sql = 'SELECT C2.'.$this->f_id.', C2.'.$this->f_left.', C2.'.$this->f_right.', COUNT(C1.'.$this->f_id.') AS level '
+		. $fields.' '	
+		. 'FROM '.$this->table.' AS C1, '.$this->table.' AS C2 %s '
+		. 'WHERE C2.'.$this->f_left.' BETWEEN C1.'.$this->f_left.' AND C1.'.$this->f_right.' '
+		. ' %s '
+		. $this->getCondition('AND','C2.')
+		. $this->getCondition('AND','C1.')
+		. 'GROUP BY C2.'.$this->f_id.', C2.'.$this->f_left.', C2.'.$this->f_right.' '.$fields.' '
+		. ' %s '
+		. 'ORDER BY C2.'.$this->f_left.' '.($sort == 'asc' ? 'ASC' : 'DESC').' ';
+		
+		$from = $where = '';
+		if ($start > 0) {
+			$from = ', '.$this->table.' AS C3';
+			$where = 'AND C3.'.$this->f_id.' = '.(integer) $start.' AND C1.'.$this->f_left.' >= C3.'.$this->f_left.' AND C1.'.$this->f_right.' <= C3.'.$this->f_right;
+			$where .= $this->getCondition('AND','C3.');
+		}
+		
+		$having = '';
+		if ($id !== null) {
+			$having = ' HAVING C2.'.$this->f_id.' = '.(integer) $id;
+		}
+		
+		$sql = sprintf($sql,$from,$where,$having);
+		
+		return $this->con->select($sql);
+	}
+	
+	public function getParents($id,$fields=array())
+	{
+		$fields = count($fields) > 0 ? ', C1.'.implode(', C1.',$fields) : '';
+		
+		return $this->con->select(
+			'SELECT C1.'.$this->f_id.' '.$fields.' '
+			. 'FROM '.$this->table.' C1, '.$this->table.' C2 '
+			. 'WHERE C2.'.$this->f_id.' = '.(integer) $id.' '
+			. 'AND C1.'.$this->f_left.' < C2.'.$this->f_left.' '
+			. 'AND C1.'.$this->f_right.' > C2.'.$this->f_right.' '
+			. $this->getCondition('AND','C2.')
+			. $this->getCondition('AND','C1.')
+			. 'ORDER BY C1.'.$this->f_left.' ASC '
+		);
+	}
+	
+	public function getParent($id,$fields=array())
+	{
+		$fields = count($fields) > 0 ? ', C1.'.implode(', C1.',$fields) : '';
+		
+		return $this->con->select(
+			'SELECT C1.'.$this->f_id.' '.$fields.' '
+			. 'FROM '.$this->table.' C1, '.$this->table.' C2 '
+			. 'WHERE C2.'.$this->f_id.' = '.(integer) $id.' '
+			. 'AND C1.'.$this->f_left.' < C2.'.$this->f_left.' '
+			. 'AND C1.'.$this->f_right.' > C2.'.$this->f_right.' '
+			. $this->getCondition('AND','C2.')
+			. $this->getCondition('AND','C1.')
+			. 'ORDER BY C1.'.$this->f_left.' DESC '
+			. $this->con->limit(1)
+		);
+	}
+	
+	/* ------------------------------------------------
+	 * Tree manipulations
+	 * ---------------------------------------------- */
+	public function addNode($data,$target=0)
+	{
+		if (!is_array($data) && !($data instanceof cursor)) {
+			throw new Exception('Invalid data block');
+		}
+		
+		if (is_array($data))
+		{
+			$D = $data;
+			$data = $this->con->openCursor($this->table);
+			foreach ($D as $k => $v) {
+				$data->{$k} = $v;
+			}
+			unset($D);
+		}
+		
+		# We want to put it at the end
+		$this->con->writeLock($this->table);
+		try
+		{
+			$rs = $this->con->select('SELECT MAX('.$this->f_id.') as n_id FROM '.$this->table);
+			$id = $rs->n_id;
+			
+			$rs = $this->con->select(
+				'SELECT MAX('.$this->f_right.') as n_r '.
+				'FROM '.$this->table.
+				$this->getCondition('WHERE')
+			);
+			$last = $rs->n_r == 0 ? 1 : $rs->n_r;
+			
+			$data->{$this->f_id} = $id+1;
+			$data->{$this->f_left} = $last+1;
+			$data->{$this->f_right} = $last+2;
+			
+			$data->insert();
+			$this->con->unlock();
+			try {
+				$this->setNodeParent($id+1,$target);
+				return $data->{$this->f_id};
+			} catch (Exception $e) {} # We don't mind error in this case
+		}
+		catch (Exception $e)
+		{
+			$this->con->unlock();
+			throw $e;
+		}
+	}
+	
+	public function deleteNode($node,$keep_children=true)
+	{
+		$node = (integer) $node;
+		
+		$rs = $this->getChildren(0,$node);
+		if ($rs->isEmpty()) {
+			throw new Exception('Node does not exist.');
+		}
+		$node_left = (integer) $rs->{$this->f_left};
+		$node_right = (integer) $rs->{$this->f_right};
+		
+		try
+		{
+			$this->con->begin();
+			
+			if ($keep_children)
+			{
+				$this->con->execute('DELETE FROM '.$this->table.' WHERE '.$this->f_id.' = '.$node);
+				
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_right.' = CASE '
+				. 	'WHEN '.$this->f_right.' BETWEEN '.$node_left.' AND '.$node_right.' '
+				.		'THEN '.$this->f_right.' - 1 '
+				.	'WHEN '.$this->f_right.' > '.$node_right.' '
+				.		'THEN '.$this->f_right.' - 2 '
+				.	'ELSE '.$this->f_right.' '
+				.	'END, '
+				. $this->f_left.' = CASE '
+				.	'WHEN '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right.' '
+				.		'THEN '.$this->f_left.' - 1 '
+				.	'WHEN '.$this->f_left.' > '.$node_right.' '
+				.		'THEN '.$this->f_left.' - 2 '
+				.	'ELSE '.$this->f_left.' '
+				.	'END '
+				. 'WHERE '.$this->f_right.' > '.$node_left
+				. $this->getCondition();
+				
+				$this->con->execute($sql);
+			}
+			else
+			{
+				$this->con->execute('DELETE FROM '.$this->table.' WHERE '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right);
+				
+				$node_delta = $node_right - $node_left + 1;
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_left.' = CASE '
+				.	'WHEN '.$this->f_left.' > '.$node_left.' '
+				.		'THEN '.$this->f_left.' - ('.$node_delta.') '
+				.	'ELSE '.$this->f_left.' '
+				.	'END, '
+				. $this->f_right.' = CASE '
+				.	'WHEN '.$this->f_right.' > '.$node_left.' '
+				.		'THEN '.$this->f_right.' - ('.$node_delta.') '
+				.	'ELSE '.$this->f_right.' '
+				.	'END '
+				. 'WHERE '.$this->f_right.' > '.$node_right
+				. $this->getCondition();
+			}
+			
+			$this->con->commit();
+		}
+		catch (Exception $e)
+		{
+			$this->con->rollback();
+			throw $e;
+		}
+	}
+	
+	public function resetOrder()
+	{
+		$rs = $this->con->select(
+			'SELECT '.$this->f_id.' '
+			.'FROM '.$this->table.' '
+			.$this->getCondition('WHERE')
+			.'ORDER BY '.$this->f_left.' ASC '
+		);
+		
+		$lft = 2;
+		$this->con->begin();
+		try
+		{
+			while ($rs->fetch()) {
+				$this->con->execute(
+					'UPDATE '.$this->table.' SET '
+					.$this->f_left.' = '.($lft++).', '
+					.$this->f_right.' = '.($lft++).' '
+					.'WHERE '.$this->f_id .' = '.(integer) $rs->{$this->f_id}.' '
+					.$this->getCondition()
+				);
+			}
+			$this->con->commit();
+		}
+		catch (Exception $e)
+		{
+			$this->con->rollback();
+			throw $e;
+		}
+	}
+	
+	public function setNodeParent($node,$target=0)
+	{
+		if ($node == $target) {
+			return;
+		}
+		$node = (integer) $node;
+		$target = (integer) $target;
+		
+		$rs = $this->getChildren(0,$node);
+		if ($rs->isEmpty()) {
+			throw new Exception('Node does not exist.');
+		}
+		$node_left = (integer) $rs->{$this->f_left};
+		$node_right = (integer) $rs->{$this->f_right};
+		$node_level = (integer) $rs->level;
+		
+		if ($target > 0)
+		{
+			$rs = $this->getChildren(0,$target);
+		}
+		else
+		{
+			$rs = $this->con->select(
+				'SELECT MIN('.$this->f_left.')-1 AS '.$this->f_left.', MAX('.$this->f_right.')+1 AS '.$this->f_right.', 0 AS level '.
+				'FROM '.$this->table.' '.
+				$this->getCondition('WHERE')
+			);
+		}
+		$target_left = (integer) $rs->{$this->f_left};
+		$target_right = (integer) $rs->{$this->f_right};
+		$target_level = (integer) $rs->level;
+		
+		if ($node_left == $target_left
+			|| ($target_left >= $node_left && $target_left <= $node_right)
+			|| ($node_level == $target_level+1 && $node_left > $target_left && $node_right < $target_right)
+		)
+		{
+			throw new Exception('Cannot move tree');
+		}
+		
+		if ($target_left < $node_left && $target_right > $node_right && $target_level < $node_level -1)
+		{
+			$sql = 'UPDATE '.$this->table.' SET '
+			. $this->f_right.' = CASE '
+			.	'WHEN '.$this->f_right.' BETWEEN '.($node_right+1).' AND '.($target_right-1).' '
+			.		'THEN '.$this->f_right.'-('.($node_right-$node_left+1).') '
+			. 	'WHEN '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_right.'+'.((($target_right-$node_right-$node_level+$target_level)/2)*2+$node_level-$target_level-1).' '
+			.	'ELSE '
+			.		$this->f_right.' '
+			.	'END, '
+			. $this->f_left.' = CASE '
+			.	'WHEN '.$this->f_left.' BETWEEN '.($node_right+1).' AND '.($target_right-1).' '
+			.		'THEN '.$this->f_left.'-('.($node_right-$node_left+1).') '
+			.	'WHEN '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_left.'+'.((($target_right-$node_right-$node_level+$target_level)/2)*2+$node_level-$target_level-1).' '
+			.	'ELSE '.$this->f_left.' '
+			.	'END '
+			. 'WHERE '.$this->f_left.' BETWEEN '.($target_left+1).' AND '.($target_right-1).'';
+		}
+		elseif ($target_left < $node_left)
+		{
+			$sql = 'UPDATE '.$this->table.' SET '
+			. $this->f_left.' = CASE '
+			.	'WHEN '.$this->f_left.' BETWEEN '.$target_right.' AND '.($node_left-1).' '
+			.		'THEN '.$this->f_left.'+'.($node_right-$node_left+1).' '
+			.	'WHEN '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_left.'-('.($node_left-$target_right).') '
+			.	'ELSE '.$this->f_left .' '
+			.	'END, '
+			. $this->f_right.' = CASE '
+			.	'WHEN '.$this->f_right.' BETWEEN '.$target_right.' AND '.$node_left.' '
+			.		'THEN '.$this->f_right.'+'.($node_right-$node_left+1).' '
+			.	'WHEN '.$this->f_right.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_right.'-('.($node_left-$target_right).') '
+			.	'ELSE '.$this->f_right.' '
+			.	'END '
+			. 'WHERE ('.$this->f_left.' BETWEEN '.$target_left.' AND '.$node_right. ' '
+			. 	'OR '.$this->f_right.' BETWEEN '.$target_left.' AND '.$node_right.')';
+		}
+		else
+		{
+			$sql = 'UPDATE '.$this->table.' SET '
+			. $this->f_left.' = CASE '
+			.	'WHEN '.$this->f_left.' BETWEEN '.$node_right.' AND '.$target_right.' '
+			.		'THEN '.$this->f_left.'-'.($node_right-$node_left+1).' '
+			.	'WHEN '.$this->f_left.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_left.'+'.($target_right-1-$node_right).' '
+			.	'ELSE '.$this->f_left.' '
+			.	'END, '
+			. $this->f_right.' = CASE '
+			.	'WHEN '.$this->f_right.' BETWEEN '.($node_right+1).' AND '.($target_right-1).' '
+			.		'THEN '.$this->f_right.'-'.($node_right-$node_left+1).' '
+			.	'WHEN '.$this->f_right.' BETWEEN '.$node_left.' AND '.$node_right.' '
+			.		'THEN '.$this->f_right.'+'.($target_right-1-$node_right).' '
+			.	'ELSE '.$this->f_right.' '
+			.	'END '
+			. 'WHERE ('.$this->f_left.' BETWEEN '.$node_left.' AND '.$target_right.' '
+			. 	'OR '.$this->f_right.' BETWEEN '.$node_left.' AND '.$target_right.')';
+		}
+		
+		$sql .= ' '.$this->getCondition();
+		
+		$this->con->execute($sql);
+	}
+	
+	public function setNodePosition($nodeA,$nodeB,$position='after')
+	{
+		$nodeA = (integer) $nodeA;
+		$nodeB = (integer) $nodeB;
+		
+		$rs = $this->getChildren(0,$nodeA);
+		if ($rs->isEmpty()) {
+			throw new Exception('Node does not exist.');
+		}
+		$A_left = $rs->{$this->f_left};
+		$A_right = $rs->{$this->f_right};
+		$A_level = $rs->level;
+		
+		$rs = $this->getChildren(0,$nodeB);
+		if ($rs->isEmpty()) {
+			throw new Exception('Node does not exist.');
+		}
+		$B_left = $rs->{$this->f_left};
+		$B_right = $rs->{$this->f_right};
+		$B_level = $rs->level;
+		
+		if ($A_level != $B_level) {
+			throw new Exception('Cannot change position');
+		}
+		
+		$rs = $this->getParents($nodeA);
+		$parentA = $rs->isEmpty() ? 0 : $rs->{$this->f_id};
+		$rs = $this->getParents($nodeB);
+		$parentB = $rs->isEmpty() ? 0 : $rs->{$this->f_id};
+		
+		if ($parentA != $parentB) {
+			throw new Exception('Cannot change position');
+		}
+		
+		if ($position == 'before')
+		{
+			if ($A_left > $B_left) {
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_right.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_right.' - ('.($A_left - $B_left).') '
+				. 'WHEN '.$this->f_left.' BETWEEN '.$B_left.' AND '.($A_left - 1).' THEN '.$this->f_right.' +  '.($A_right - $A_left + 1).' ELSE '.$this->f_right.' END, '
+				. $this->f_left.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_left.' - ('.($A_left - $B_left).') '
+				. 'WHEN '.$this->f_left.' BETWEEN '.$B_left.' AND '.($A_left - 1).' THEN '.$this->f_left.' + '.($A_right - $A_left + 1).' ELSE '.$this->f_left.' END '
+				. 'WHERE '.$this->f_left.' BETWEEN '.$B_left.' AND '.$A_right;
+			} else {
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_right.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_right.' + '.(($B_left - $A_left) - ($A_right - $A_left + 1)).' '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($A_right + 1).' AND '.($B_left - 1).' THEN '.$this->f_right.' - ('.(($A_right - $A_left + 1)).') ELSE '.$this->f_right.' END, '
+				. $this->f_left.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_left.' + '.(($B_left - $A_left) - ($A_right - $A_left + 1)).' '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($A_right + 1).' AND '.($B_left - 1).' THEN '.$this->f_left.' - ('.($A_right - $A_left + 1).') ELSE '.$this->f_left.' END '
+				. 'WHERE '.$this->f_left.' BETWEEN '.$A_left.' AND '.($B_left - 1);
+			}
+		}
+		else
+		{
+			if ($A_left > $B_left) {
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_right.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_right.' - ('.($A_left - $B_left - ($B_right - $B_left + 1)).') '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($B_right + 1).' AND '.($A_left - 1).' THEN '.$this->f_right.' +  '.($A_right - $A_left + 1).' ELSE '.$this->f_right.' END, '
+				. $this->f_left.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_left.' - ('.($A_left - $B_left - ($B_right - $B_left + 1)).') '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($B_right + 1).' AND '.($A_left - 1).' THEN '.$this->f_left.' + '.($A_right - $A_left + 1).' ELSE '.$this->f_left.' END '
+				. 'WHERE '.$this->f_left.' BETWEEN '.($B_right + 1).' AND '.$A_right;
+			} else {
+				$sql = 'UPDATE '.$this->table.' SET '
+				. $this->f_right.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_right.' + '.($B_right - $A_right).' '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($A_right + 1).' AND '.$B_right.' THEN '.$this->f_right.' - ('.(($A_right - $A_left + 1)).') ELSE '.$this->f_right.' END, '
+				. $this->f_left.' = CASE WHEN '.$this->f_left.' BETWEEN '.$A_left.' AND '.$A_right.' THEN '.$this->f_left.' + '.($B_right - $A_right).' '
+				. 'WHEN '.$this->f_left.' BETWEEN '.($A_right + 1).' AND '.$B_right.' THEN '.$this->f_left.' - ('.($A_right - $A_left + 1).') ELSE '.$this->f_left.' END '
+				. 'WHERE '.$this->f_left.' BETWEEN '.$A_left.' AND '.$B_right;
+			}
+		}
+		
+		$sql .= $this->getCondition();
+		$this->con->execute($sql);
+	}
+	
+	protected function getCondition($start='AND',$prefix='')
+	{
+		if (empty($this->add_condition)) {
+			return '';
+		}
+		
+		$w = array();
+		foreach ($this->add_condition as $c => $n) {
+			$w[] = $prefix.$c.' = '.$n;
+		}
+		return ' '.$start.' '.implode(' AND ',$w).' ';
+	}
+}
+?>
